
(********************************************************************
  module CursorAPI
    definition of cursor API
 ********************************************************************)

type xName      = string
type xAttribute = xName * string
type xData      = Data of string
                | Node of xName * xAttribute list

module type CURSOR =
  sig
    (* the type used as an cursor *)
    type cursor

    (* move operations *)
    val prev    : cursor -> cursor
    val next    : cursor -> cursor
    val up      : cursor -> cursor
    val down    : cursor -> cursor

    (* edit operations *)
    val get     : cursor -> xData
    val set     : xData  -> cursor -> cursor
    val insertA : xData  -> cursor -> cursor
    val insertB : xData  -> cursor -> cursor
    val remove  : cursor -> cursor
  end
